local addonName, addonTable = ...
local name, _, _, enabled = GetAddOnInfo("tekDebug")
local player = UnitName("player")
local enabled = GetAddOnEnableState(player, "tekDebug") == 2
if enabled and not IsAddOnLoaded("tekDebug") then
  local succ, err = LoadAddOn(name)
end
local debugf = tekDebug and tekDebug:GetFrame(addonName)
local function DebugPrint(...) if debugf then debugf:AddMessage(string.join(", ", tostringall(...))) end end
DebugPrint("RelicHelper loaded.")

-- used as the key in the SV
RelicHelper_SV = RelicHelper_SV or {}

local MAX_RELIC_NUM = 3 
local currChar -- Unique name-realm identifier for database storage
local currArtifact
local specToRelics = {
	[250] = {RELIC_SLOT_TYPE_BLOOD, RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_IRON}, -- Blood DK
	[251] = {RELIC_SLOT_TYPE_FROST, RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_FROST}, -- Frost DK
	[252] = {RELIC_SLOT_TYPE_FIRE, RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_BLOOD}, -- Unholy DK

	[577] = {RELIC_SLOT_TYPE_FEL, RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_FEL}, -- Havoc DH
	[581] = {RELIC_SLOT_TYPE_IRON, RELIC_SLOT_TYPE_ARCANE, RELIC_SLOT_TYPE_FEL}, -- Vengeance DH

	[102] = {RELIC_SLOT_TYPE_ARCANE, RELIC_SLOT_TYPE_LIFE, RELIC_SLOT_TYPE_ARCANE}, -- Balance Druid
	[103] = {RELIC_SLOT_TYPE_FROST, RELIC_SLOT_TYPE_BLOOD, RELIC_SLOT_TYPE_LIFE}, -- Feral Druid
	[104] = {RELIC_SLOT_TYPE_FIRE, RELIC_SLOT_TYPE_BLOOD, RELIC_SLOT_TYPE_LIFE}, -- Guardian Druid
	[105] = {RELIC_SLOT_TYPE_LIFE, RELIC_SLOT_TYPE_FROST, RELIC_SLOT_TYPE_LIFE}, -- Restoration Druid

	[253] = {RELIC_SLOT_TYPE_WIND, RELIC_SLOT_TYPE_ARCANE, RELIC_SLOT_TYPE_IRON}, -- Beast Mastery Hunter
	[254] = {RELIC_SLOT_TYPE_WIND, RELIC_SLOT_TYPE_BLOOD, RELIC_SLOT_TYPE_LIFE}, -- Marksmanship Hunter
	[255] = {RELIC_SLOT_TYPE_WIND, RELIC_SLOT_TYPE_IRON, RELIC_SLOT_TYPE_BLOOD}, -- Survival Hunter

	[62] = {RELIC_SLOT_TYPE_ARCANE, RELIC_SLOT_TYPE_FROST, RELIC_SLOT_TYPE_ARCANE}, -- Arcane Mage
	[63] = {RELIC_SLOT_TYPE_FIRE, RELIC_SLOT_TYPE_ARCANE, RELIC_SLOT_TYPE_FIRE}, -- Fire Mage
	[64] = {RELIC_SLOT_TYPE_FROST, RELIC_SLOT_TYPE_ARCANE, RELIC_SLOT_TYPE_FROST}, -- Frost Mage

	[268] = {RELIC_SLOT_TYPE_LIFE, RELIC_SLOT_TYPE_WIND, RELIC_SLOT_TYPE_IRON}, -- Brewmaster Monk
	[270] = {RELIC_SLOT_TYPE_FROST, RELIC_SLOT_TYPE_LIFE, RELIC_SLOT_TYPE_WIND}, -- Mistweaver Monk
	[269] = {RELIC_SLOT_TYPE_WIND, RELIC_SLOT_TYPE_IRON, RELIC_SLOT_TYPE_WIND}, -- Windwalker Monk

	[65] = {RELIC_SLOT_TYPE_HOLY, RELIC_SLOT_TYPE_LIFE, RELIC_SLOT_TYPE_HOLY}, -- Holy Paladin
	[66] = {RELIC_SLOT_TYPE_HOLY, RELIC_SLOT_TYPE_IRON, RELIC_SLOT_TYPE_ARCANE}, -- Protection Paladin
	[70] = {RELIC_SLOT_TYPE_HOLY, RELIC_SLOT_TYPE_FIRE, RELIC_SLOT_TYPE_HOLY}, -- Retribution Paladin

	[256] = {RELIC_SLOT_TYPE_HOLY, RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_HOLY}, -- Discipline Priest
	[257] = {RELIC_SLOT_TYPE_HOLY, RELIC_SLOT_TYPE_LIFE, RELIC_SLOT_TYPE_HOLY}, -- Holy Priest
	[258] = {RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_BLOOD, RELIC_SLOT_TYPE_SHADOW}, -- Shadow Priest

	[259] = {RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_IRON, RELIC_SLOT_TYPE_BLOOD}, -- Assassination Rogue
	[260] = {RELIC_SLOT_TYPE_BLOOD, RELIC_SLOT_TYPE_IRON, RELIC_SLOT_TYPE_WIND}, -- Outlaw Rogue
	[261] = {RELIC_SLOT_TYPE_FEL, RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_FEL}, -- Subtlety Rogue

	[262] = {RELIC_SLOT_TYPE_WIND, RELIC_SLOT_TYPE_FROST, RELIC_SLOT_TYPE_WIND}, -- Elemental Shaman
	[263] = {RELIC_SLOT_TYPE_FIRE, RELIC_SLOT_TYPE_IRON, RELIC_SLOT_TYPE_WIND}, -- Enhancement Shaman
	[264] = {RELIC_SLOT_TYPE_LIFE, RELIC_SLOT_TYPE_FROST, RELIC_SLOT_TYPE_LIFE}, -- Restoration Shaman

	[265] = {RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_BLOOD, RELIC_SLOT_TYPE_SHADOW}, -- Affliction Warlock
	[266] = {RELIC_SLOT_TYPE_SHADOW, RELIC_SLOT_TYPE_FIRE, RELIC_SLOT_TYPE_FEL}, -- Demonology Warlock
	[267] = {RELIC_SLOT_TYPE_FEL, RELIC_SLOT_TYPE_FIRE, RELIC_SLOT_TYPE_FEL}, -- Destruction Warlock

	[71] = {RELIC_SLOT_TYPE_IRON, RELIC_SLOT_TYPE_BLOOD, RELIC_SLOT_TYPE_SHADOW}, -- Arms Warrior
	[72] = {RELIC_SLOT_TYPE_FIRE, RELIC_SLOT_TYPE_WIND, RELIC_SLOT_TYPE_IRON}, -- Fury Warrior
	[73] = {RELIC_SLOT_TYPE_IRON, RELIC_SLOT_TYPE_BLOOD, RELIC_SLOT_TYPE_FIRE}, -- Protection Warrior
}
local RELIC_TOOLTIP_TYPE_PATTERN = _G.RELIC_TOOLTIP_TYPE:gsub('%%s', '(.+)')


local RH = CreateFrame("Frame")

RH.Events = {}
RH:RegisterEvent("ADDON_LOADED")
RH:RegisterEvent("PLAYER_LOGIN")
RH:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
RH:RegisterEvent("ARTIFACT_UPDATE")
RH:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
--RH:RegisterEvent("")

RH:SetScript("OnEvent",function( self, event, ...)
  DebugPrint(event,...)
  self.Events[event](self, ...)
end)


RH.Events["ADDON_LOADED"] = function( self, loadedAddon )
  if loadedAddon ~= addonName then return end
  self:UnregisterEvent("ADDON_LOADED")
  DebugPrint("RelicHelper loaded.")
end

RH.Events["PLAYER_LOGIN"] = function( self )
  currChar = UnitName("player").."-"..GetRealmName()
  self:UpdateArtifactName()
  DebugPrint("PLAYER_LOGIN", currChar, currArtifact)
  if not currArtifact then return end
  self:UpdateDB()
end

function RH:InitArtifact()
  self:UpdateArtifactName()
  DebugPrint(currChar, currArtifact)
  if not currArtifact then return end
  self:UpdateDB()
  self:ScanArtifact()
end

RH.Events["ARTIFACT_UPDATE"] = function( self )
  self:InitArtifact()
end

RH.Events["PLAYER_EQUIPMENT_CHANGED"] = function( self )
  self:InitArtifact()
end

function RH:ScanArtifact()
  DebugPrint("ScanArtifact")
  local relicTypeData = specToRelics[(GetSpecializationInfo(GetSpecialization()))]
  local relicData = RelicHelper_SV[currChar][currArtifact]
  for i=1,MAX_RELIC_NUM do
    local _, relicName, relicItemID, relicItemLink = C_ArtifactUI.GetEquippedArtifactRelicInfo(i)
    if relicName then
      relicData[i]["ilvlBonus"] = C_ArtifactUI.GetItemLevelIncreaseProvidedByRelic( relicItemLink )
      relicData[i]["type"]      = relicTypeData[i]
      DebugPrint(relicName, relicData[i]["ilvlBonus"], relicData[i]["type"])
    else
      relicData[i]["ilvlBonus"] = 0
      relicData[i]["type"]      = relicTypeData[i]
      DebugPrint("Empty relic slot", 0, relicData[i]["type"])
    end
  end
end

function RH:UpdateArtifactName()
  local _, _, name = C_ArtifactUI.GetEquippedArtifactInfo()
  currArtifact = name 
  DebugPrint("UpdateArtifactName", currArtifact)
end

function RH:UpdateDB()
  RelicHelper_SV[currChar] = RelicHelper_SV[currChar] or {}
  RelicHelper_SV[currChar][currArtifact] = RelicHelper_SV[currChar][currArtifact] or {}
  if RelicHelper_SV[currChar][currArtifact][1] then return end
  for i=1,MAX_RELIC_NUM do
    RelicHelper_SV[currChar][currArtifact][i] = {}
  end
end

function RH.manageTooltip(tooltip, ... )
  local name, link = tooltip:GetItem()
  local ilvlBonus = C_ArtifactUI.GetItemLevelIncreaseProvidedByRelic(link)
  if ilvlBonus then

    local relicType, t, i, j
    for i=1,tooltip:NumLines() do
      if relicType then break end
      t = _G[tooltip:GetName().."TextLeft"..i]:GetText()
      relicType = t:match(RELIC_TOOLTIP_TYPE_PATTERN)
    end
    
    if not relicType then
      DebugPrint(name, link, ilvlBonus, "no type")
    else
      DebugPrint(name, link, ilvlBonus, relicType)
      local data = RelicHelper_SV[currChar]
      for i=1,tooltip:NumLines() do
        local line = _G[tooltip:GetName().."TextLeft"..i]:GetText()
        if data[line] then
          DebugPrint(i, line)
          for j=1,MAX_RELIC_NUM do
            --if relicType == data[line][j]["type"] and ilvlBonus > data[line][j]["ilvlBonus"] then
            DebugPrint(ilvlBonus, data[line][j]["type"], data[line][j]["ilvlBonus"])
            if relicType == data[line][j]["type"] then
              local relBonus = ilvlBonus - data[line][j]["ilvlBonus"]
              
              _G[tooltip:GetName().."TextLeft"..i]:SetText(_G[tooltip:GetName().."TextLeft"..i]:GetText() .. ( relBonus > 0 and " (|cFF00FF00+" or  " (|cFFFF0000").. relBonus.."|r)")
            end
          end
        end
      end
    end
  end
  tooltip:Show()
end

-- overload the base function for ItemRefTooltip with a custom routine
ItemRefTooltip:HookScript("OnTooltipSetItem", function(tooltip, ...)
  RH.manageTooltip(tooltip, ...)
end)
GameTooltip:HookScript("OnTooltipSetItem", function(tooltip, ...)
  RH.manageTooltip(tooltip, ...)
end)
WorldMapTooltip.ItemTooltip.Tooltip:HookScript("OnTooltipSetItem", function(tooltip, ...)
  RH.manageTooltip(tooltip, ...)
end)